
/*

delimiter $$
DROP PROCEDURE IF EXISTS PROC_NAME;
$$
CREATE PROCEDURE  `PROC_NAME`()
BEGIN
 
END
$$


*/
-- START APP
    -- APP_get_token_validation_MQTTAuth

        DELIMITER $$
        DROP PROCEDURE IF EXISTS APP_get_token_validation_MQTTAuth;
        $$

        CREATE PROCEDURE `APP_get_token_validation_MQTTAuth`( token_var VARCHAR(45), iduser_var INT, idgroup_var INT, iddevice_var INT, mqtt_username_var VARCHAR(200) )
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=iddevice_var, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	

            INSERT e3t.users_mqttauth_log (date, iduser, idgroup, iddevice, token, mqtt_username, result)
            SELECT NOW(), iduser_var, idgroup_var, iddevice_var, token_var, mqtt_username_var, @result;

            SELECT @result result, idplatform from users where id=iduser_var limit 1;
        END
        $$
		
    
-- END APP

-- START CRON
    -- CRON_get_alerts

        DELIMITER $$
        DROP PROCEDURE IF EXISTS CRON_get_alerts;
        $$

        CREATE PROCEDURE `CRON_get_alerts`()
        BEGIN
            SELECT * FROM baltoro.alerts where enabled = 1;
        END
		$$
		

        DELIMITER $$
        DROP PROCEDURE IF EXISTS CRON_get_epanet_gateways_data;
        $$

        CREATE PROCEDURE `CRON_get_epanet_gateways_data`()
        BEGIN

            SELECT D.id iddevice, (
                SELECT MAX(SS.date)
                FROM e3t.middleware_udp_sensor_synchronous_sender_log SS
                WHERE SS.iddevice = D.id
                AND SS.idsensor = 2
            ) AS date, (
                SELECT SS.`values_summary`
                FROM e3t.middleware_udp_sensor_synchronous_sender_log SS
                WHERE SS.iddevice = D.id
                AND SS.idsensor = 2
                AND SS.date = (
                    SELECT MAX(SS2.date)
                    FROM e3t.middleware_udp_sensor_synchronous_sender_log SS2
                    WHERE SS2.iddevice = D.id
                    AND SS2.idsensor = 2
                )
            ) AS values_summary,
            ExtractValue(D.parameters, 'parameters/k2_factor') factor,
            ExtractValue(D.descriptors, 'descriptors/epanet_node_id') epanet_node_id
            FROM e3t.devices D
            WHERE D.idgroup = idgroup_var
            AND D.descriptors LIKE '%epanet_node_id%';

        END
		$$
		

    -- CRON_get_data_by_alert

        DELIMITER $$
        DROP PROCEDURE IF EXISTS CRON_get_data_by_alert;
        $$

        CREATE PROCEDURE `CRON_get_data_by_alert`(idalert_var INT(11))
        BEGIN

            DECLARE iddevice_var TEXT;
            DECLARE iddevice_compare_var TEXT;
            DECLARE BUS_iddevice_var TEXT;
            DECLARE BUS_iddevice_compare_var TEXT;
            DECLARE type_alert_var INT(2);
            DECLARE iddata_type_var INT(2);
            
            SELECT 
                iddevice, iddevice_compare, BUS_iddevice, BUS_iddevice_compare, type_alert, iddata_type
                INTO iddevice_var, iddevice_compare_var, BUS_iddevice_var, BUS_iddevice_compare_var, type_alert_var, iddata_type_var
                FROM baltoro.alerts
                WHERE  id = idalert_var;
                
            IF type_alert_var = 1  -- Threshold Utility
                THEN
                
                    IF iddata_type_var = 1  -- Pressure S+
                        THEN
                            SET @din_query = CONCAT('SELECT * FROM e3t.middleware_sensors_stats_day WHERE iddevice in (', iddevice_var, ') ');
                                    
                            SET @din_query = CONCAT(@din_query, ' AND DATEDIFF(NOW(),date_local) = 1;');
                                        
                            PREPARE smpt FROM @din_query;
                            EXECUTE smpt;
                            DEALLOCATE PREPARE smpt;
                    END IF;
                    
                    IF iddata_type_var = 2  -- Water S+
                        THEN
                            SET @din_query = CONCAT('SELECT * FROM e3t.middleware_meters_stats_day_water WHERE iddevice in (', iddevice_var, ') ');
                                    
                            IF BUS_iddevice_var IS NOT NULL
                                THEN
                                    SET @din_query = CONCAT(@din_query, ' AND BUS_iddevice in (', BUS_iddevice_var, ') ');
                            END IF;
                        
                            SET @din_query = CONCAT(@din_query, ' AND DATEDIFF(NOW(),date_local) = 1;');
                                        
                            PREPARE smpt FROM @din_query;
                            EXECUTE smpt;
                            DEALLOCATE PREPARE smpt;
                            
                            SET @din_query_comp = CONCAT('SELECT * FROM e3t.middleware_meters_stats_day_water WHERE iddevice in (', iddevice_compare_var, ') ');
                                    
                            IF BUS_iddevice_compare_var IS NOT NULL
                                THEN
                                    SET @din_query_comp = CONCAT(@din_query_comp, ' AND BUS_iddevice in (', BUS_iddevice_compare_var, ') ');
                            END IF;
                        
                            SET @din_query_comp = CONCAT(@din_query_comp, ' AND DATEDIFF(NOW(),date_local) = 1;');
                                    
                            PREPARE smpt FROM @din_query_comp;
                            EXECUTE smpt;
                            DEALLOCATE PREPARE smpt;
                    END IF;
            END IF;
            
            IF type_alert_var = 2  -- Variation Utility
            THEN        
                IF iddata_type_var = 2  -- Water S+
                THEN
                    SET @din_query = CONCAT('SELECT * FROM e3t.middleware_meters_stats_day_water WHERE iddevice in (', iddevice_var, ') ');
                            
                    IF BUS_iddevice_var IS NOT NULL
                    THEN
                        SET @din_query = CONCAT(@din_query, ' AND BUS_iddevice in (', BUS_iddevice_var, ') ');
                    END IF;
                
                    SET @din_query = CONCAT(@din_query, ' AND (DATEDIFF(NOW(),date_local) = 1 OR DATEDIFF(NOW(),date_local) = 2) ORDER BY date_local DESC;');
                                
                    PREPARE smpt FROM @din_query;
                    EXECUTE smpt;
                    DEALLOCATE PREPARE smpt;
                    
                    SET @din_query_comp = CONCAT('SELECT * FROM e3t.middleware_meters_stats_day_water WHERE iddevice in (', iddevice_compare_var, ') ');
                            
                    IF BUS_iddevice_compare_var IS NOT NULL
                    THEN
                        SET @din_query_comp = CONCAT(@din_query_comp, ' AND BUS_iddevice in (', BUS_iddevice_compare_var, ') ');
                    END IF;
                
                    SET @din_query_comp = CONCAT(@din_query_comp, ' AND DATEDIFF(NOW(),date_local) = 1;');
                            
                    PREPARE smpt FROM @din_query_comp;
                    EXECUTE smpt;
                    DEALLOCATE PREPARE smpt;
                END IF;
            END IF;
            
        END
		$$
		

    -- CRON_get_data_by_alert_old

        DELIMITER $$
        DROP PROCEDURE IF EXISTS CRON_get_data_by_alert_old;
        $$

        CREATE PROCEDURE `CRON_get_data_by_alert_old`(idalert_var INT(11))
        BEGIN

            DECLARE iddevice_var TEXT;
            DECLARE iddevice_compare_var TEXT;
            DECLARE BUS_iddevice_var TEXT;
            DECLARE BUS_iddevice_compare_var TEXT;
            DECLARE type_alert_var INT(2);

            SELECT 
                iddevice, iddevice_compare, BUS_iddevice, BUS_iddevice_compare, type_alert
                INTO iddevice_var, iddevice_compare_var, BUS_iddevice_var, BUS_iddevice_compare_var, type_alert_var
                FROM baltoro.alerts
                WHERE  id = idalert_var;
                
            IF type_alert_var = 1 -- Night Compsuption
                THEN
            
                    SET @din_query = CONCAT('SELECT * FROM e3t.middleware_meters_stats_day_water WHERE iddevice in (', iddevice_var, ') ');
                            
                    IF BUS_iddevice_var IS NOT NULL
                        THEN
                            SET @din_query = CONCAT(@din_query, ' AND BUS_iddevice in (', BUS_iddevice_var, ') ');
                    END IF;
                
                    SET @din_query = CONCAT(@din_query, ' AND DATEDIFF(NOW(),date_local) = 1;');
                    
                    -- SELECT @din_query;
                    
                    PREPARE smpt FROM @din_query;
                    EXECUTE smpt;
                    DEALLOCATE PREPARE smpt;
                    
                    SET @din_query_comp = CONCAT('SELECT * FROM e3t.middleware_meters_stats_day_water WHERE iddevice in (', iddevice_compare_var, ') ');
                            
                    IF BUS_iddevice_compare_var IS NOT NULL
                        THEN
                            SET @din_query_comp = CONCAT(@din_query_comp, ' AND BUS_iddevice in (', BUS_iddevice_compare_var, ') ');
                    END IF;
                
                    SET @din_query_comp = CONCAT(@din_query_comp, ' AND DATEDIFF(NOW(),date_local) = 1;');
                            
                    -- SELECT @din_query;
                    
                    PREPARE smpt FROM @din_query_comp;
                    EXECUTE smpt;
                    DEALLOCATE PREPARE smpt;
                    
                END IF;
                
            IF type_alert_var = 3  -- Consumption threshold daily
                THEN
                    SET @din_query = CONCAT('SELECT * FROM e3t.middleware_meters_stats_day_water WHERE iddevice in (', iddevice_var, ') ');
                            
                    IF BUS_iddevice_var IS NOT NULL
                        THEN
                            SET @din_query = CONCAT(@din_query, ' AND BUS_iddevice in (', BUS_iddevice_var, ') ');
                    END IF;
                
                    SET @din_query = CONCAT(@din_query, ' AND DATEDIFF(NOW(),date_local) = 1;');
                                
                    PREPARE smpt FROM @din_query;
                    EXECUTE smpt;
                    DEALLOCATE PREPARE smpt;
                    
                    SET @din_query_comp = CONCAT('SELECT * FROM e3t.middleware_meters_stats_day_water WHERE iddevice in (', iddevice_compare_var, ') ');
                            
                    IF BUS_iddevice_compare_var IS NOT NULL
                        THEN
                            SET @din_query_comp = CONCAT(@din_query_comp, ' AND BUS_iddevice in (', BUS_iddevice_compare_var, ') ');
                    END IF;
                
                    SET @din_query_comp = CONCAT(@din_query_comp, ' AND DATEDIFF(NOW(),date_local) = 1;');
                            
                    PREPARE smpt FROM @din_query_comp;
                    EXECUTE smpt;
                    DEALLOCATE PREPARE smpt;
            END IF;
            
            IF type_alert_var = 5  -- Pressure threshold daily
                THEN
                    SET @din_query = CONCAT('SELECT * FROM e3t.middleware_sensors_stats_day WHERE iddevice in (', iddevice_var, ') ');
                            
                    SET @din_query = CONCAT(@din_query, ' AND DATEDIFF(NOW(),date_local) = 1;');
                                
                    PREPARE smpt FROM @din_query;
                    EXECUTE smpt;
                    DEALLOCATE PREPARE smpt;
                    
                END IF;
                
            /*IF type_alert_var = 2  -- Consumption threshold measure
                THEN
                    SELECT 1;
                END IF;
                

                
            IF type_alert_var = 4  -- Pressure threshold measure
                THEN
                    SELECT 1;
                END IF;
            */

        END
		$$
		

    -- CRON_post_alert_log

        DELIMITER $$
        DROP PROCEDURE IF EXISTS CRON_post_alert_log;
        $$

        CREATE PROCEDURE `CRON_post_alert_log`( id_alert_var INT(11), value_inf_var VARCHAR(45), value_sup_var VARCHAR(45), night_compsuption_var VARCHAR(45), values_var TEXT )
        BEGIN

            INSERT INTO `baltoro`.`alerts_log` (`id_alert`, `date`, `value_inf`, `vaule_sup`, `night_compsuption`, `values`) 
                    VALUES (id_alert_var, NOW(), value_inf_var, value_sup_var, night_compsuption_var, values_var);
                    
            UPDATE `baltoro`.`alerts` SET `active` = '1' WHERE (`id` = id_alert_var);

        END
		$$
		

-- END CRON

-- START DELETE
    -- DELETE_alert

        DELIMITER $$
        DROP PROCEDURE IF EXISTS DELETE_alert;
        $$

        CREATE PROCEDURE `DELETE_alert`(iduser_var INT, idalert_var INT(11))
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                    
            DELETE FROM `baltoro`.`alerts` WHERE (`id` = idalert_var);

        END
		$$
		

    -- DELETE_alert_log

        DELIMITER $$
        DROP PROCEDURE IF EXISTS DELETE_alert_log;
        $$

        CREATE PROCEDURE `DELETE_alert_log`(iduser_var INT, idalert_log_var INT(11))
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                    

            DELETE FROM `baltoro`.`alerts_log` WHERE (`id` = idalert_log_var);

        END
		$$
		

    -- DELETE_sector

        DELIMITER $$
        DROP PROCEDURE IF EXISTS DELETE_sector;
        $$

        CREATE PROCEDURE `DELETE_sector`(iduser_var INT, idsector_var INT)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
            
            DELETE FROM `baltoro`.`sector_labels` WHERE (`id` = idsector_var);

            UPDATE baltoro.labels_iddevice LD
                SET `sectors` = (SELECT JSON_REMOVE(sectors, CONCAT('$."', idsector_var, '"')))
                WHERE JSON_EXTRACT(LD.sectors, CONCAT('$."', idsector_var, '"')) IS NOT NULL;
        END
		$$
		

    -- DELETE_sector_gateway

        DELIMITER $$
        DROP PROCEDURE IF EXISTS DELETE_sector_gateway;
        $$

        CREATE PROCEDURE `DELETE_sector_gateway`(iduser_var INT, iddevice_var INT, idsector_var INT)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=iddevice_var, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                        
            DELETE FROM `baltoro`.`sector_labels` WHERE (`id` = idsector_var);

            UPDATE baltoro.labels_iddevice LD
                SET `sectors` = (SELECT JSON_REMOVE(sectors, CONCAT('$."', idsector_var, '"')))
                WHERE LD.iddevice=iddevice_var;
        END
		$$
		

    -- DELETE_service

        DELIMITER $$
        DROP PROCEDURE IF EXISTS DELETE_service;
        $$

        CREATE PROCEDURE `DELETE_service`(iduser_var INT, idservice_var INT)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                        
            DELETE FROM `baltoro`.`service_labels` WHERE (`id` = idservice_var);
            UPDATE `baltoro`.`labels_iddevice` SET `idservice` = NULL WHERE (`idservice` = idservice_var);

        END
		$$
		

    -- DELETE_user

        DELIMITER $$
        DROP PROCEDURE IF EXISTS DELETE_user;
        $$

        CREATE PROCEDURE `DELETE_user`(iduser_var INT, iduser_delete_var INT)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
            
            DELETE FROM `baltoro`.`users` WHERE (`id` = iduser_delete_var);
            
        END
		$$
		

-- END DELETE

-- START GET
    -- GET_alerts

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_alerts;
        $$

        CREATE PROCEDURE `GET_alerts`(iduser_var INT, idgroup_var INT(11))
        PROC:BEGIN

                CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result);

                IF @result=0
                THEN
                    SELECT 'Validation' ERROR;
                    LEAVE PROC;
                END IF;	
            
                SET @din_query = CONCAT('SELECT A.*FROM baltoro.alerts A WHERE idgroup_home=', idgroup_var,';');
                    
                PREPARE smpt FROM @din_query;
                
                EXECUTE smpt;
                
                DEALLOCATE PREPARE smpt;
                    

        END
		$$
		

    -- GET_alerts_log

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_alerts_log;
        $$

        CREATE PROCEDURE `GET_alerts_log`(iduser_var INT, idgroup_var INT(11), date_start_var VARCHAR(25), date_end_var VARCHAR(25) )
        PROC:BEGIN

                -- CALL baltoro. GET_alerts_log('jZa2tJ3wQhkFj1pDye2ap9dvYXt3Y42DBmZxbV2D', 393, 0, 0);
                
                CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result);

                IF @result=0
                THEN
                    SELECT 'Validation' ERROR;
                    LEAVE PROC;
                END IF;	
            
                SET @din_query = CONCAT('SELECT A.*, AL.*
                                        FROM baltoro.alerts_log AL 
                                        INNER JOIN baltoro.alerts A ON A.id = AL.id_alert 
                                        WHERE A.idgroup_home = ', idgroup_var);
                                                                
                IF(date_start_var !=0)
                THEN
                    SET @din_query=CONCAT(@din_query, ' AND AL.date >= ''', date_start_var,'''');
                END IF;

                IF(date_end_var !=0)
                THEN
                    SET @din_query=CONCAT(@din_query, ' AND AL.date <= ''', date_end_var,'''');
                END IF;
                        
                SET @din_query=CONCAT(@din_query, ' AND AL.date >= ''', date_start_var,'''');

                SET @din_query=CONCAT(@din_query, ' ORDER BY AL.date DESC');
                
                -- SELECT@din_query;
                
                PREPARE smpt FROM @din_query;
                
                EXECUTE smpt;
                
                DEALLOCATE PREPARE smpt;
                    
        END
		$$
		

    -- GET_data_type

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_data_type;
        $$

        CREATE PROCEDURE GET_data_type(iduser_var INT)
        PROC:BEGIN

                CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result);

                IF @result=0
                THEN
                    SELECT 'Validation' ERROR;
                    LEAVE PROC;
                END IF;    
            
                SET @din_query = CONCAT('SELECT * FROM baltoro.data_type;');
                    
                PREPARE smpt FROM @din_query;
                
                EXECUTE smpt;
                
                DEALLOCATE PREPARE smpt;
                    

        END
		$$
		

    -- GET_frame_log_by_technology

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_frame_log_by_technology;
        $$

        CREATE PROCEDURE `GET_frame_log_by_technology`( iduser_var int, iddevice_var int, BUS_iddevice_var VARCHAR(200), technology_var VARCHAR(5), rows_var INT, date_start_var VARCHAR(25), date_end_var VARCHAR(25) )
        PROC:BEGIN
            -- CALL baltoro.GET_frame_log_by_technology ( '3e9c81b54a8da8c42bed08cc5e1b313f', 109116661, 0, 'F',20, '2021-07-012', '2021-07-13' )

                CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=iddevice_var, @result);

                IF @result=0
                THEN
                    SELECT 'Validation' ERROR;
                    LEAVE PROC;
                END IF;

                SET @din_query= CONCAT('SELECT 	F.date, F.TS, F.data
                                        FROM e3t.middleware_udp_frame_log F
                                        WHERE F.iddevice=', iddevice_var);

                IF(date_start_var!=0)
                THEN
                    SET @din_query=CONCAT(@din_query, '
                                        AND F.date >= ''', date_start_var,'''');
                END IF;

                IF(date_end_var!=0)
                THEN
                    SET @din_query=CONCAT(@din_query, '
                                        AND F.date <= ''', date_end_var,'''');
                END IF;
                
                IF(technology_var!='0')
                THEN
                    SET @din_query=CONCAT(@din_query, '
                                        AND INSTR(F.message, "|', technology_var,'|")','
                                        AND INSTR(F.message, "|', technology_var,'|")<25'
                                        );
                END IF;
            
                SET @din_query=CONCAT(@din_query, '
                                        ORDER BY F.date DESC, F.id DESC');

                IF(rows_var!=0)
                THEN
                    SET @din_query=CONCAT(@din_query, '
                                        LIMIT ', rows_var);
                END IF;
                
                -- preparamos el objete Statement a partir de nuestra variable
                PREPARE smpt FROM @din_query;
                -- ejecutamos el Statement
                EXECUTE smpt;
                -- liberamos la memoria
                DEALLOCATE PREPARE smpt;
            
        END
		$$
		

    -- GET_gateway_data_summary

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateway_data_summary;
        $$

        CREATE PROCEDURE `GET_gateway_data_summary`( iduser_var INT, iddevice_var INT, group_hour_var INT, last_data_var INT, date_start_var VARCHAR(25), date_end_var VARCHAR(25))
        PROC:BEGIN
            
            DECLARE pulse_var INT(1);
            DECLARE sensor_var INT(1);

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=iddevice_var, @result);

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
            
            SET SQL_SAFE_UPDATES = 0;

            SET pulse_var = (SELECT ExtractValue(parameters, 'parameters/pulse_on') FROM e3t.devices WHERE id = iddevice_var);
            SET sensor_var = (SELECT IF((SELECT DT.name FROM e3t.devices D INNER JOIN e3t.devices_types DT ON D.idtype=DT.id WHERE D.id = iddevice_var) LIKE '%PIPE20P%', 1, 0));
            SET SESSION group_concat_max_len = 999999;

            IF(pulse_var != 0)
            THEN
                SET @consulta= CONCAT('SELECT date, idsensor_type, idsensor,',IF(group_hour_var = 1, 'GROUP_CONCAT(values_summary) values_summary', 'values_summary'),
                                        ' FROM e3t.middleware_udp_sensor_synchronous_sender_log WHERE iddevice=', iddevice_var,
                                        IF(sensor_var = 0, ' AND idsensor_type = 6 ', ' '));

                IF(last_data_var=0)
                THEN
                    SET @consulta=CONCAT(@consulta, '
                                            AND date >= ''', date_start_var,'''');
            -- 								AND date >= ''', DATE_SUB(date_start_var, INTERVAL 1 HOUR),'''');
                    SET @consulta=CONCAT(@consulta, '
                                            AND date <= ''', date_end_var,'''');
                ELSE
                    SET @consulta=CONCAT(@consulta, '
                                        AND date = (SELECT MAX(date) from e3t.middleware_udp_sensor_synchronous_sender_log WHERE iddevice=', iddevice_var,' ) ');
                END IF;
                
                SET @consulta=CONCAT(@consulta, 
                                    IF(group_hour_var = 1, ' GROUP BY LEFT(date, 13), idsensor_type, idsensor', ''), ' ORDER BY date DESC, id DESC ');
                -- preparamos el objete Statement a partir de nuestra variable
                PREPARE smpt FROM @consulta;
                -- ejecutamos el Statement
                EXECUTE smpt;
                -- liberamos la memoria
                DEALLOCATE PREPARE smpt;
                
                -- SELECT @consulta;
            END IF;   
        END
		$$
		

    -- GET_gateway_data_summary_city

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateway_data_summary_city;
        $$

        CREATE PROCEDURE `GET_gateway_data_summary_city`( iduser_var INT, iddevice_var INT, last_data_var INT, date_start_var VARCHAR(25), date_end_var VARCHAR(25))
        PROC:BEGIN
                    
            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=iddevice_var, @result);

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	

            SET SQL_SAFE_UPDATES = 0;

            SET SESSION group_concat_max_len = 999999;
        -- e3t.baltoro_magnitudes_values
            SET @consulta= CONCAT('SELECT date, `values` FROM e3t.baltoro_magnitudes_values WHERE iddevice=', iddevice_var);

            IF(last_data_var=0)
            THEN
                SET @consulta=CONCAT(@consulta, '
                AND date >= ''', date_start_var,'''');

                SET @consulta=CONCAT(@consulta, '
                AND date <= ''', date_end_var,'''');
            ELSE
                SET @consulta=CONCAT(@consulta, '
                AND date = (SELECT date from e3t.baltoro_magnitudes_values WHERE iddevice=', iddevice_var,' order by date desc LIMIT 1) ');
            END IF;

            SET @consulta=CONCAT(@consulta, 
                                ' ORDER BY date DESC, id DESC ');
                                
            -- preparamos el objeto Statement a partir de nuestra variable
            PREPARE smpt FROM @consulta;
            
            -- ejecutamos el Statement
            EXECUTE smpt;
            
            -- liberamos la memoria
            DEALLOCATE PREPARE smpt;
            
            -- SELECT @consulta;
                
        END
		$$
		

    -- GET_gateway_data_summary_day_city

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateway_data_summary_day_city;
        $$

        CREATE PROCEDURE `GET_gateway_data_summary_day_city`( iduser_var INT, iddevice_var INT, last_day_var INT, date_start_var VARCHAR(25), date_end_var VARCHAR(25))
        PROC:BEGIN
                    
            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=iddevice_var, @result);

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	

            SET SQL_SAFE_UPDATES = 0;

            SET SESSION group_concat_max_len = 999999;
        -- e3t.baltoro_magnitudes_values_day
            SET @consulta= CONCAT('SELECT date, `values` FROM e3t.baltoro_magnitudes_values_day WHERE iddevice=', iddevice_var);

            IF(last_day_var=0)
            THEN
                SET @consulta=CONCAT(@consulta, '
                AND date >= ''', date_start_var,'''');

                SET @consulta=CONCAT(@consulta, '
                AND date <= ''', date_end_var,'''');
            ELSE
                SET @consulta=CONCAT(@consulta, '
                AND date = (SELECT date from e3t.baltoro_magnitudes_values_day WHERE iddevice=', iddevice_var,' order by date desc LIMIT 1) ');
            END IF;

            SET @consulta=CONCAT(@consulta, 
                                ' ORDER BY date DESC, id DESC ');
                                
            -- preparamos el objeto Statement a partir de nuestra variable
            PREPARE smpt FROM @consulta;
            
            -- ejecutamos el Statement
            EXECUTE smpt;
            
            -- liberamos la memoria
            DEALLOCATE PREPARE smpt;
            
            -- SELECT @consulta;
                
        END
		$$
		

    -- GET_gateway_data_summary_week_city

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateway_data_summary_week_city;
        $$

        CREATE PROCEDURE `GET_gateway_data_summary_week_city`( iduser_var INT, iddevice_var INT, last_week_var INT, date_start_var VARCHAR(25), date_end_var VARCHAR(25))
        PROC:BEGIN
                    
            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=iddevice_var, @result);

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	

            SET SQL_SAFE_UPDATES = 0;

            SET SESSION group_concat_max_len = 999999;
        -- e3t.baltoro_magnitudes_values_week
            SET @consulta= CONCAT('SELECT date, `values` FROM e3t.baltoro_magnitudes_values_week WHERE iddevice=', iddevice_var);

            IF(last_week_var=0)
            THEN
                SET @consulta=CONCAT(@consulta, '
                AND date >= ''', date_start_var,'''');

                SET @consulta=CONCAT(@consulta, '
                AND date <= ''', date_end_var,'''');
            ELSE
                SET @consulta=CONCAT(@consulta, '
                AND date = (SELECT date from e3t.baltoro_magnitudes_values_week WHERE iddevice=', iddevice_var,' order by date desc LIMIT 1) ');
            END IF;

            SET @consulta=CONCAT(@consulta, 
                                ' ORDER BY date DESC, id DESC ');
                                
            -- preparamos el objeto Statement a partir de nuestra variable
            PREPARE smpt FROM @consulta;
            
            -- ejecutamos el Statement
            EXECUTE smpt;
            
            -- liberamos la memoria
            DEALLOCATE PREPARE smpt;
            
            -- SELECT @consulta;
                
        END
        $$
		

    -- GET_gateway_data_summary_day_sensor

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateway_data_summary_day_sensor;
        $$

        CREATE PROCEDURE `GET_gateway_data_summary_day_sensor`(iduser_var int, iddevices_var TEXT, type_var INT(1), date_start_var DATETIME, date_end_var DATETIME)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result);

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	

            -- CALL baltoro.GET_gateway_data_summary_day_sensor('', '(610029275,610029270)', '("610029275_2","610029270_2")', 0, "2022-08-29 00:00:00", "2022-09-06 23:59:59");

            SET SQL_SAFE_UPDATES = 0;

            IF(type_var = 0 )
                THEN
                    SET @consulta = CONCAT('SELECT id, date_local, iddevice, value_max, value_avg, value_min, value_q3, value_q1, value_med, max_diff,  readings');
                END IF;
                
            IF(type_var = 1 )
                THEN
                    SET @consulta = CONCAT('SELECT id, date_local, iddevice, value_max, value_avg, value_min, value_q3, value_q1, value_med, max_diff');
                END IF;
                
            IF(type_var = 2 )
                THEN
                    SET @consulta = CONCAT('SELECT id, date_local, iddevice, readings');
                END IF;
                
            SET @consulta = CONCAT(@consulta, '
                            FROM e3t.middleware_sensors_stats_day
                            WHERE iddevice in ', iddevices_var, 
                            ' AND date_local >= "', date_start_var,
                            '" AND date_local <= "', date_end_var, '"');
            -- SELECT @consulta;

            -- preparamos el objete Statement a partir de nuestra variable
            PREPARE smpt FROM @consulta;
            -- ejecutamos el Statement
            EXECUTE smpt;
            -- liberamos la memoria
            DEALLOCATE PREPARE smpt;
            
        END
		$$
		

    -- GET_gateway_data_summary_day_water

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateway_data_summary_day_water;
        $$

        CREATE PROCEDURE `GET_gateway_data_summary_day_water`(iduser_var int, iddevices_var TEXT, BUS_iddevices_var TEXT, type_var INT(1), date_start_var DATETIME, date_end_var DATETIME)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result);

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	

            SET SQL_SAFE_UPDATES = 0;

            IF(type_var = 0 )
                THEN
                    SET @consulta = CONCAT('SELECT id, date_local, iddevice, BUS_iddevice, value_day, value_max, value_avg, value_min, value_night, period_lenght, total_period, total, offset, readings');
                END IF;
                
            IF(type_var = 1 )
                THEN
                    SET @consulta = CONCAT('SELECT id, date_local, iddevice, BUS_iddevice, value_day, value_max, value_avg, value_min, value_night, period_lenght, total_period, total, offset');
                END IF;
                
            IF(type_var = 2 )
                THEN
                    SET @consulta = CONCAT('SELECT id, date_local, iddevice, BUS_iddevice, readings');
                END IF;
                
            SET @consulta = CONCAT(@consulta, '
                            FROM e3t.middleware_meters_stats_day_water
                            WHERE iddevice in ', iddevices_var, 
                            ' AND BUS_iddevice in ', BUS_iddevices_var,
                            ' AND date_local >= "', date_start_var,
                            '" AND date_local <= "', date_end_var, '"');
            -- SELECT @consulta;

            -- preparamos el objete Statement a partir de nuestra variable
            PREPARE smpt FROM @consulta;
            -- ejecutamos el Statement
            EXECUTE smpt;
            -- liberamos la memoria
            DEALLOCATE PREPARE smpt;
            
            
        END
		$$
		

    -- GET_gateway_data_summary_delete

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateway_data_summary_delete;
        $$

        CREATE PROCEDURE `GET_gateway_data_summary_delete`( iddevice_var INT, group_hour_var INT(1), last_data_var INT(1), date_start_var DATETIME, date_end_var DATETIME)
        PROC:BEGIN
            
            DECLARE pulse_var INT(1);
            DECLARE sensor_var INT(1);

            SET SQL_SAFE_UPDATES = 0;

            SET pulse_var = (SELECT ExtractValue(parameters, 'parameters/pulse_on') FROM e3t.devices WHERE id = iddevice_var);
            SET sensor_var = (SELECT IF((SELECT DT.name FROM e3t.devices D INNER JOIN e3t.devices_types DT ON D.idtype=DT.id WHERE D.id = iddevice_var) LIKE '%PIPE20P%', 1, 0));
            SET SESSION group_concat_max_len = 999999;

            IF(pulse_var != 0)
            THEN
                SET @consulta= CONCAT('SELECT date, idsensor_type, idsensor,',IF(group_hour_var = 1, 'GROUP_CONCAT(values_summary) values_summary', 'values_summary'),
                                        ' FROM e3t.middleware_udp_sensor_synchronous_sender_log WHERE iddevice=', iddevice_var,
                                        IF(sensor_var = 0, ' AND idsensor_type = 6 ', ' '));

                IF(last_data_var=0)
                THEN
                    SET @consulta=CONCAT(@consulta, '
                                            AND date >= ''', date_start_var,'''');
            -- 								AND date >= ''', DATE_SUB(date_start_var, INTERVAL 1 HOUR),'''');
                    SET @consulta=CONCAT(@consulta, '
                                            AND date <= ''', date_end_var,'''');
                ELSE
                    SET @consulta=CONCAT(@consulta, '
                                        AND date = (SELECT MAX(date) from e3t.middleware_udp_sensor_synchronous_sender_log WHERE iddevice=', iddevice_var,' ) ');
                END IF;
                
                SET @consulta=CONCAT(@consulta, 
                                    IF(group_hour_var = 1, ' GROUP BY LEFT(date, 13), idsensor_type, idsensor', ''), ' ORDER BY date DESC, id DESC ');
                -- preparamos el objete Statement a partir de nuestra variable
                PREPARE smpt FROM @consulta;
                -- ejecutamos el Statement
                EXECUTE smpt;
                -- liberamos la memoria
                DEALLOCATE PREPARE smpt;                
                -- SELECT @consulta;
            END IF;   
        END
		$$
		
        
        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateway_data_compare_gateways;
        $$

        CREATE PROCEDURE `GET_gateway_data_compare_gateways`(iduser_var INT, iddevices_var TEXT, offset_time INT, date_start_var DATETIME, date_end_var DATETIME)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result);

           IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	

            SET SQL_SAFE_UPDATES = 0;
		    SET SESSION group_concat_max_len = 999999;

			SET @consulta = CONCAT('SELECT id, date_local, iddevice, readings');

            
            SET @consulta = CONCAT('SELECT id, date_local, iddevice, readings, 1 register_type, NULL last_readings  FROM e3t.middleware_sensors_stats_day 
                            WHERE iddevice in (', iddevices_var, 
                            ') AND DATE(date_local) >= "', DATE(date_start_var),
                            '" AND DATE(date_local) <= "', DATE(date_end_var), '"');
                            
			IF (CURDATE() = DATE(date_end_var))
				THEN
                                
                SET @consulta = CONCAT(@consulta, ' UNION SELECT id, "', (CONCAT(DATE(date_end_var), ' 00:00:00')) , '" date_local, iddevice, GROUP_CONCAT(`values_summary` SEPARATOR ",") readings, 2 register_type, GROUP_CONCAT(`value_last` SEPARATOR ",") last_readings FROM e3t.middleware_udp_sensor_synchronous_sender_log  
                            WHERE iddevice in (', iddevices_var, 
                            ') AND idsensor_type = 1 AND date >= "', DATE_SUB(CONCAT(DATE(date_end_var), ' 00:00:00'), INTERVAL offset_time HOUR),
                            '" AND date <= "', date_end_var, '"
                            GROUP BY iddevice;');
			END IF;
            
            -- SELECT @consulta;

            -- preparamos el objete Statement a partir de nuestra variable
            PREPARE smpt FROM @consulta;
            -- ejecutamos el Statement
            EXECUTE smpt;
            -- liberamos la memoria
            DEALLOCATE PREPARE smpt;
            
            
        END
		$$
		

    -- GET_gateway_info

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateway_info;
        $$

        CREATE PROCEDURE `GET_gateway_info`(iduser_var INT, iddevice_var INT)
        PROC:BEGIN

            DECLARE MODBUS_device_type_var INT(2);

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=iddevice_var, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	

            SET SQL_SAFE_UPDATES = 0;
            SET SESSION group_concat_max_len = 999999;

            SET MODBUS_device_type_var = (SELECT ExtractValue(descriptors, 'descriptors/MODBUS_device_type') FROM e3t.devices WHERE id = iddevice_var); 

            SET @consulta= CONCAT('
                SELECT  D.id, D.name, D.ref, D.idtype, DT.name type_name, D.idgroup, D.idstatus, D.group_master, D.mac, D.icc, D.GPS_lat, D.GPS_lng, D.parameters, D.descriptors, D.display_options, D.timezone, D.version_firmware, D.parameters_BUS,
                        MUD.parameters Dparameters, MUD.Sensor Dsensor, MUD.Registers Registers, G.name group_name, SE.name service_name, SE.color service_color, SE.tag service_tag, SE.description service_description, SE.id idservice,
                        SL.sectors');

            IF(MODBUS_device_type_var)
            THEN	
            
                SET @consulta= CONCAT(@consulta, 
                    ", (SELECT JSON_ARRAYAGG(JSON_OBJECT('idfield', DF.idfield, 'Decimals', DF.Decimals, 'Description', DF.Description, 'Unit', DF.Unit))
                    FROM e3t.middleware_MODBUS_devices_types_data_format DF
                    WHERE iddevice_type =", MODBUS_device_type_var," AND Description <> 'Discard') AS JSON_sensors");

                IF MODBUS_device_type_var = 6
                THEN
                    SET @consulta= CONCAT(@consulta, 
                        ", (SELECT JSON_ARRAYAGG(JSON_OBJECT('OS_ID', OS.id, 'DS_ID', DS.id))
                        FROM e3t.devices_measurements DM 
                        INNER JOIN e3t.outputs_status OS ON OS.id=DM.idstatus 
                        LEFT JOIN e3t.devices_status DS ON DS.id=DM.idstatus_connection 
                        WHERE DM.iddevice =", iddevice_var,") AS JSON_status");
                END IF;

            ELSE    
                IF((SELECT COUNT(*) FROM e3t.middleware_udp_devices_BUS_devices where iddevice = iddevice_var AND BUS_type IS NOT NULL) != 0)
                THEN	
                
                    SET @consulta= CONCAT(@consulta,  
                        ", (SELECT JSON_ARRAYAGG(JSON_OBJECT('BUS_iddevice', BD.BUS_iddevice, 'descriptors_BUS', BD.descriptors_BUS))
                        FROM e3t.middleware_udp_devices_BUS_devices BD
                        WHERE iddevice =", iddevice_var," AND BUS_type IS NOT NULL) AS JSON_BUS_device");

                END IF; 
            END IF; 
            
            SET @consulta= CONCAT(@consulta,
                ' FROM 		e3t.devices D
                INNER JOIN 	e3t.devices_types DT 			ON DT.id=D.idtype
                LEFT JOIN 	e3t.`groups` G 					ON G.id=D.idgroup
                LEFT JOIN 	baltoro.labels_iddevice SL 		ON D.id = SL.iddevice 
                LEFT JOIN 	baltoro.service_labels SE 		ON SL.idservice = SE.id 
                LEFT JOIN 	e3t.middleware_udp_devices MUD 	ON MUD.iddevice=D.id
                LEFT JOIN   e3t.middleware_udp_devices_BUS_devices BD ON BD.iddevice=D.id
                WHERE D.id=', iddevice_var,' GROUP BY id;');

            -- preparamos el objete Statement a partir de nuestra variable
            PREPARE smpt FROM @consulta;

            -- ejecutamos el Statement
            EXECUTE smpt;
            
            -- liberamos la memoria
            DEALLOCATE PREPARE smpt;
            
            -- SELECT @consulta;
        END
		$$
		

    -- GET_gateway_info_delete

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateway_info_delete;
        $$

        CREATE PROCEDURE `GET_gateway_info_delete`(iddevice_var INT)
        PROC:BEGIN

            -- CALL baltoro.GET_device ( 1 )
            SET @row_number=0;
            SELECT     @row_number:=@row_number+1 AS `row_number`,
                    D.id, D.name, D.ref, D.idtype, DT.name type_name, D.idgroup, D.group_master, D.mac, D.icc, D.GPS_lat, D.GPS_lng, G.name group_name, D.parameters, D.descriptors, D.display_options, D.timezone, D.version_firmware,
                    MUD.parameters Dparameters, MUD.Sensor Dsensor, MUD.Registers Registers, D.parameters_BUS, SE.name service_name, SE.color service_color, SE.tag service_tag, SE.description service_description, SE.id idservice, SL.sectors
            from e3t.devices D
            inner join e3t.devices_types DT on DT.id=D.idtype
            left join e3t.`groups` G ON G.id=D.idgroup
            left join baltoro.labels_iddevice SL on D.id = SL.iddevice 
            left join baltoro.service_labels SE on SL.idservice = SE.id 
            left join e3t.middleware_udp_devices MUD ON MUD.iddevice=D.id
            where D.id=iddevice_var
            group by id;
        END
		$$
		

    -- GET_gateways

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateways;
        $$

        CREATE PROCEDURE `GET_gateways`(iduser_var INT, idgroup_var INT, subgroups_var INT, iddevice_type_var INT)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
            
            -- CALL baltoro.GET_group_devices ( '393', '0', '0' );

                SET SQL_SAFE_UPDATES = 0;

                DROP TEMPORARY TABLE IF EXISTS Temp_Table_groups;
                CREATE TEMPORARY TABLE Temp_Table_groups (id int NOT NULL PRIMARY KEY AUTO_INCREMENT, idgroup int NOT NULL, KEY idgroup (idgroup));

                DROP TEMPORARY TABLE IF EXISTS Temp_Table_groups_copy2;
                CREATE TEMPORARY TABLE Temp_Table_groups_copy2 (id int NOT NULL PRIMARY KEY AUTO_INCREMENT, idgroup int NOT NULL, KEY idgroup (idgroup));


            if (subgroups_var =0 OR subgroups_var IS NULL)
            then
                SET @row_number=0;
                
                CALL Hierarchical_group_subgroups ( idgroup_var );
                
                insert Temp_Table_groups_copy2 select * from Temp_Table_groups;
                
                SELECT 	@row_number:=@row_number+1 AS `row_number`,
                        D.id, D.name, D.idtype, D.idgroup, D.GPS_lat, D.GPS_lng, G.name group_name,  D.ref OP, DT.name type_name, D.version_firmware, D.mac IMEI, SE.name service_name, SE.color service_color, SE.tag service_tag, SE.description service_description, SE.id idservice, SL.sectors, ExtractValue(D.descriptors, 'descriptors/MODBUS_device_type') MODBUS_device_type
                from e3t.devices D
                inner join e3t.`groups` G on G.id=D.idgroup
                left join baltoro.labels_iddevice SL on D.id = SL.iddevice 
                left join baltoro.service_labels SE on SL.idservice = SE.id 
                inner join e3t.devices_types DT on DT.id=D.idtype
                where D.idgroup=idgroup_var and (iddevice_type_var=0 or D.idtype=iddevice_type_var)
                group by D.id
                order by group_name, D.name;

            else
                begin
                    
                    CALL Hierarchical_group_subgroups ( idgroup_var );
                    
                    insert Temp_Table_groups_copy2 select * from Temp_Table_groups;

                    SET @row_number=0;
                    SELECT 	@row_number:=@row_number+1 AS `row_number`,
                            D.id, D.name, D.idtype, D.idgroup, D.GPS_lat, D.GPS_lng, G.name group_name,  D.ref OP, DT.name type_name, D.version_firmware, D.mac IMEI, SE.name service_name, SE.color service_color, SE.tag service_tag, SE.description service_description, SE.id idservice, SL.sectors, ExtractValue(D.descriptors, 'descriptors/MODBUS_device_type') MODBUS_device_type
                    from e3t.devices D
                    inner join e3t.`groups` G on G.id=D.idgroup
                    left join baltoro.labels_iddevice SL on D.id = SL.iddevice 
                    left join baltoro.service_labels SE on SL.idservice = SE.id 
                    inner join e3t.devices_types DT on DT.id=D.idtype
                    inner join Temp_Table_groups TTG on TTG.idgroup=D.idgroup
                    where (iddevice_type_var=0 or D.idtype=iddevice_type_var)
                    group by D.id
                    order by lft, group_name, D.name;
                    
                end;
            end if;
        END
		$$
		

    -- GET_gateways_city

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateways_city;
        $$

        CREATE PROCEDURE `GET_gateways_city`(iduser_var INT, idgroup_var INT, subgroups_var INT, iddevice_type_var INT)
        PROC:BEGIN

            -- CALL baltoro.GET_gateways_city('tVzsPRSkeQAmMAOtJlhcakhlwEFhdNZbigkCzpny',518,1,0);
                CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result); 

                IF @result=0
                THEN
                    SELECT 'Validation' ERROR;
                    LEAVE PROC;
                END IF;	
            
                SET SQL_SAFE_UPDATES = 0;

                DROP TEMPORARY TABLE IF EXISTS Temp_Table_groups;
                CREATE TEMPORARY TABLE Temp_Table_groups (id int NOT NULL PRIMARY KEY AUTO_INCREMENT, idgroup int NOT NULL, KEY idgroup (idgroup));

                DROP TEMPORARY TABLE IF EXISTS Temp_Table_groups_copy2;
                CREATE TEMPORARY TABLE Temp_Table_groups_copy2 (id int NOT NULL PRIMARY KEY AUTO_INCREMENT, idgroup int NOT NULL, KEY idgroup (idgroup));


            if (subgroups_var =0 OR subgroups_var IS NULL)
            then
                SET @row_number=0;
                
                CALL Hierarchical_group_subgroups ( idgroup_var );
                
                insert Temp_Table_groups_copy2 select * from Temp_Table_groups;
                
                SELECT 	@row_number:=@row_number+1 AS `row_number`,
                        D.id, D.name, D.idtype, D.idgroup, D.GPS_lat, D.GPS_lng, G.name group_name,  D.ref OP, DT.name type_name, D.version_firmware, D.mac IMEI,  ST.id solutions_id, P.name solutions_name, MUD.Pdate Pdate, ExtractValue(D.descriptors, 'descriptors/MODBUS_device_type') MODBUS_device_type
                from e3t.devices D
                inner join e3t.`groups` G on G.id=D.idgroup
                left join baltoro.solutions_type ST on ST.id=ExtractValue(D.descriptors, 'descriptors/solutions_type')
                inner join baltoro.portals P on P.id=ST.idportal
                inner join e3t.devices_types DT on DT.id=D.idtype
                left join e3t.middleware_udp_devices MUD on MUD.iddevice=D.id 
                where D.idgroup=idgroup_var and (iddevice_type_var=0 or D.idtype=iddevice_type_var)
                group by D.id
                order by group_name, D.name;

            else
                begin
                    
                    CALL Hierarchical_group_subgroups ( idgroup_var );
                    
                    insert Temp_Table_groups_copy2 select * from Temp_Table_groups;

                    SET @row_number=0;
                    SELECT 	@row_number:=@row_number+1 AS `row_number`,
                            D.id, D.name, D.idtype, D.idgroup, D.GPS_lat, D.GPS_lng, G.name group_name,  D.ref OP, DT.name type_name, D.version_firmware, D.mac IMEI, ST.id solutions_id, P.name solutions_name, MUD.Pdate Pdate, ExtractValue(D.descriptors, 'descriptors/MODBUS_device_type') MODBUS_device_type
                    from e3t.devices D
                    inner join e3t.`groups` G on G.id=D.idgroup
                    left join baltoro.solutions_type ST on ST.id=ExtractValue(D.descriptors, 'descriptors/solutions_type')
                    inner join baltoro.portals P on P.id=ST.idportal
                    inner join e3t.devices_types DT on DT.id=D.idtype
                    left join e3t.middleware_udp_devices MUD on MUD.iddevice=D.id 
                    inner join Temp_Table_groups TTG on TTG.idgroup=D.idgroup
                    where (iddevice_type_var=0 or D.idtype=iddevice_type_var)
                    group by D.id
                    order by lft, group_name, D.name;
                    
                end;
            end if;
        END
		$$
		

    -- GET_gateways_alert

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_gateways_alert;
        $$

        CREATE PROCEDURE `GET_gateways_alert`(iduser_var INT, idgroup_var INT, subgroups_var INT, iddevice_type_var INT)
        PROC:BEGIN

            -- CALL baltoro.GET_gateways_alert('tVzsPRSkeQAmMAOtJlhcakhlwEFhdNZbigkCzpny',518,1,0);
                CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result); 

                IF @result=0
                THEN
                    SELECT 'Validation' ERROR;
                    LEAVE PROC;
                END IF;	
            
                SET SQL_SAFE_UPDATES = 0;

                DROP TEMPORARY TABLE IF EXISTS Temp_Table_groups;
                CREATE TEMPORARY TABLE Temp_Table_groups (id int NOT NULL PRIMARY KEY AUTO_INCREMENT, idgroup int NOT NULL, KEY idgroup (idgroup));

                DROP TEMPORARY TABLE IF EXISTS Temp_Table_groups_copy2;
                CREATE TEMPORARY TABLE Temp_Table_groups_copy2 (id int NOT NULL PRIMARY KEY AUTO_INCREMENT, idgroup int NOT NULL, KEY idgroup (idgroup));


            if (subgroups_var =0 OR subgroups_var IS NULL)
            then
                SET @row_number=0;
                
                CALL Hierarchical_group_subgroups ( idgroup_var );
                
                insert Temp_Table_groups_copy2 select * from Temp_Table_groups;
                
                SELECT 	@row_number:=@row_number+1 AS `row_number`,
                        D.id, D.name, D.idtype, D.idgroup, D.GPS_lat, D.GPS_lng, G.name group_name,  D.ref OP, DT.name type_name, D.version_firmware, D.mac IMEI, MUD.Pdate Pdate, ExtractValue(D.descriptors, 'descriptors/MODBUS_device_type') MODBUS_device_type
                from e3t.devices D
                inner join e3t.`groups` G on G.id=D.idgroup
                -- left join baltoro.solutions_type ST on ST.id=ExtractValue(D.descriptors, 'descriptors/solutions_type')
                -- inner join baltoro.portals P on P.id=ST.idportal
                inner join e3t.devices_types DT on DT.id=D.idtype
                left join e3t.middleware_udp_devices MUD on MUD.iddevice=D.id 
                where D.idgroup=idgroup_var and (iddevice_type_var=0 or D.idtype=iddevice_type_var)
                group by D.id
                order by group_name, D.name;

            else
                begin
                    
                    CALL Hierarchical_group_subgroups ( idgroup_var );
                    
                    insert Temp_Table_groups_copy2 select * from Temp_Table_groups;

                    SET @row_number=0;
                    SELECT 	@row_number:=@row_number+1 AS `row_number`,
                            D.id, D.name, D.idtype, D.idgroup, D.GPS_lat, D.GPS_lng, G.name group_name,  D.ref OP, DT.name type_name, D.version_firmware, D.mac IMEI, MUD.Pdate Pdate, ExtractValue(D.descriptors, 'descriptors/MODBUS_device_type') MODBUS_device_type
                    from e3t.devices D
                    inner join e3t.`groups` G on G.id=D.idgroup
                    -- left join baltoro.solutions_type ST on ST.id=ExtractValue(D.descriptors, 'descriptors/solutions_type')
                    -- inner join baltoro.portals P on P.id=ST.idportal
                    inner join e3t.devices_types DT on DT.id=D.idtype
                    left join e3t.middleware_udp_devices MUD on MUD.iddevice=D.id 
                    inner join Temp_Table_groups TTG on TTG.idgroup=D.idgroup
                    where (iddevice_type_var=0 or D.idtype=iddevice_type_var)
                    group by D.id
                    order by lft, group_name, D.name;
                    
                end;
            end if;
        END
		$$
		

    -- GET_solutions

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_solutions;
        $$

        CREATE PROCEDURE `GET_solutions`(iduser_var INT)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
            
	        SELECT ST.id idsolution, P.id idportal, ST.name solution, P.name portal FROM baltoro.solutions_type ST INNER JOIN baltoro.portals P ON ST.idportal = P.id;
            
        END
		$$
		

    -- GET_group_info

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_group_info;
        $$

        CREATE PROCEDURE `GET_group_info`(iduser_var INT, idgroup_var INT)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	

            -- CALL baltoro.GET_group_info ('', 1 )
            
            SET SQL_SAFE_UPDATES = 0;

            DROP TEMPORARY TABLE IF EXISTS Temp_Table_groups;
            CREATE TEMPORARY TABLE Temp_Table_groups (id int NOT NULL PRIMARY KEY AUTO_INCREMENT, idgroup int NOT NULL, KEY idgroup (idgroup));

            CALL e3t.Hierarchical_group_path ( idgroup_var);
        
            SET @logo=(SELECT logo
            FROM Temp_Table_groups TTG
            INNER JOIN e3t.`groups` G ON G.id=TTG.idgroup
            WHERE G.logo IS NOT NULL
            ORDER BY TTG.id DESC LIMIT 1);


            DELETE FROM Temp_Table_groups;

            CALL e3t.Hierarchical_group_subgroups ( idgroup_var );

            SELECT GROUP_CONCAT(parent.id ORDER BY parent.lft ASC SEPARATOR '/')
            FROM e3t.`groups` AS node,
                    e3t.`groups` AS parent
            WHERE node.lft BETWEEN parent.lft AND parent.rgt
                    AND node.id = idgroup_var
            into @group_path;


            SELECT G.id, G.name, G.description, G.idplatform, G.parent, G.lft, G.rgt, G.GPS_lat, G.GPS_lng, display_options,
                    (select name from e3t.`groups` where id=G.parent) group_origin,
                    (select count(*)-1 from Temp_Table_groups) `groups`,
                    (select count(*) from e3t.devices where idgroup=idgroup_var) devices,
                    CASE WHEN G.logo IS NULL THEN @logo ELSE logo END as logo, iddashboard_type, @group_path group_path
            FROM e3t.`groups` G 
            WHERE G.id=idgroup_var
            GROUP BY G.id;

            -- SELECT * FROM baltoro.sector_labels WHERE idgroup = idgroup_var;
        END
		$$
		

    -- GET_meters_info

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_meters_info;
        $$

        CREATE PROCEDURE `GET_meters_info`(iduser_var INT, idgroup_var INT, iddevice_var INT, BUS_iddevice_var VARCHAR(45))
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=iddevice_var, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	

            -- CALL baltoro.GET_meters_info ( ''',  109020860, '109020860_2')

            SET SQL_SAFE_UPDATES = 0;

			IF EXISTS(SELECT * FROM labels_iddevice WHERE iddevice = iddevice_var)
            THEN
				SET @consulta = CONCAT('SELECT * FROM e3t.middleware_udp_devices_BUS_devices BD INNER JOIN labels_iddevice LD ON BD.iddevice = LD.iddevice  WHERE BD.iddevice = ',iddevice_var);
			ELSE
				SET @consulta = CONCAT('SELECT * FROM e3t.middleware_udp_devices_BUS_devices BD WHERE iddevice = ',iddevice_var);
			END IF;
            
            IF(BUS_iddevice_var != 0 )
                THEN
                    SET @consulta = CONCAT(@consulta, ' and BD.BUS_iddevice = "', BUS_iddevice_var,'"');
            END IF;

            SET @consulta = CONCAT(@consulta, ';');

            -- preparamos el objete Statement a partir de nuestra variable
            PREPARE smpt FROM @consulta;
            -- ejecutamos el Statement
            EXECUTE smpt;
            -- liberamos la memoria
            DEALLOCATE PREPARE smpt;
            
            -- SELECT @consulta;
            
        END
		$$
		

    -- GET_multitenant_list

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_multitenant_list;
        $$

        CREATE PROCEDURE `GET_multitenant_list`(iduser_var INT, idgroup_var INT, idportal INT)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
            
	    SELECT M.idgroup, G.name, M.idportal FROM baltoro.multitenant M INNER JOIN e3t.`groups` G ON M.idgroup = G.id where M.idportal = idportal OR idportal = 0;
                    
        END
		$$
		

    -- GET_reset_password_token

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_reset_password_token;
        $$

        CREATE PROCEDURE `GET_reset_password_token`(email_var varchar(255))
        proc_label:begin
            
            DECLARE recovery_token VARCHAR(150);
            DECLARE iduser_var INT;
            
            SET SQL_SAFE_UPDATES = 0;

            SET recovery_token = lpad(conv(floor(rand()*pow(36,6)), 10, 36), 6, 0);
            SET iduser_var = (SELECT id FROM baltoro.users WHERE email=email_var LIMIT 1);
                
            IF( iduser_var IS NULL)
            THEN
            
                SELECT 0 error;
                
            ELSE
                        
                IF EXISTS(SELECT * FROM baltoro.reset_password_tokens WHERE iduser=iduser_var)
                THEN
                    UPDATE baltoro.reset_password_tokens SET token = recovery_token WHERE iduser = iduser_var;			
                ELSE
                    INSERT INTO baltoro.reset_password_tokens (token, iduser) VALUES (recovery_token, iduser_var);        
                END IF;
                
                SELECT user, name, email, language, recovery_token, iduser_var FROM baltoro.users WHERE email=email_var LIMIT 1;		

            END IF;
            
        END
        $$
		

    -- GET_sectors

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_sectors;
        $$

        CREATE PROCEDURE `GET_sectors`(iduser_var INT, idgroup_var INT)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
            
            SELECT * FROM baltoro.sector_labels where idgroup=idgroup_var;
            
        END
		$$
		

    -- GET_services

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_services;
        $$

        CREATE PROCEDURE `GET_services`(iduser_var INT, idgroup_var INT)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
            
            SELECT * FROM baltoro.service_labels where idgroup=idgroup_var;
            
        END
		$$
		

    -- GET_token

        DELIMITER $$
        DROP PROCEDURE IF EXISTS GET_token;
        $$

        CREATE PROCEDURE `GET_token`(iduser_var INT(5))
        BEGIN
            SELECT id FROM baltoro.sessions where user_id = iduser_var;
        END
		$$
		

-- END GET

-- Hierarchical_group_subgroups

    DELIMITER $$
    DROP PROCEDURE IF EXISTS Hierarchical_group_subgroups;
    $$

    CREATE PROCEDURE `Hierarchical_group_subgroups`( idgroup_var INT )
    begin
        -- CALL e3t.Hierarchical_group_subgroups ( 1 )
        -- SELECT * FROM Temp_Table_groups;

        DROP TEMPORARY TABLE IF EXISTS Temp_Table_groups;
        CREATE TEMPORARY TABLE IF NOT EXISTS Temp_Table_groups (id int NOT NULL PRIMARY KEY AUTO_INCREMENT, idgroup int NOT NULL, INDEX idgroup (idgroup));

        -- SUBNIVELES BAJO UN SUBNIVEL
        INSERT Temp_Table_groups (idgroup)
        SELECT node.id idgroup
        FROM e3t.`groups` AS node,
                e3t.`groups` AS parent,
                e3t.`groups` AS sub_parent,
                (
                        SELECT node.id, (COUNT(parent.id) - 1) AS depth
                        FROM e3t.`groups` AS node,
                                e3t.`groups` AS parent
                        WHERE node.lft BETWEEN parent.lft AND parent.rgt
                                AND node.id = idgroup_var
                        GROUP BY node.id
                        ORDER BY node.lft
                )AS sub_tree
        WHERE node.lft BETWEEN parent.lft AND parent.rgt
                AND node.lft BETWEEN sub_parent.lft AND sub_parent.rgt
                AND sub_parent.id = sub_tree.id
        GROUP BY node.id
        -- PARA VER SOLO LOS SUBNIVELES DIRECTOS
        -- HAVING depth <= 1
        -- PARA NO VER EL NIVEL:
        -- HAVING idgroup != idgroup_var
        ORDER BY node.lft;

    END
    $$
    
--

-- START POST
    -- POST_alert

        DELIMITER $$
        DROP PROCEDURE IF EXISTS POST_alert;
        $$

        CREATE PROCEDURE `POST_alert`(iduser_var INT, idgroup_var INT, alert_XML TEXT CHARSET UTF8)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                    
            /*
            CALL baltoro.Post_baltoro_alerts (1,
                                    '<alert>
                                        <iddevice>1</iddevice>
                                        <BUS_iddevice>1</BUS_iddevice>
                                        <type_alarm>1</type_alarm>
                                        <limit_inf>0</limit_inf>
                                        <limit_sup>10</limit_sup>
                                        <formula>#max_diff# < #limit_inf#<formula>
                                        <email>jrudilla@datakorum.com</email>
                                        <iddevice_compare>1</iddevice_compare>
                                        <BUS_iddevice_compare>1</BUS_iddevice_compare>
                                    </alert>' );
            */
            
            INSERT `baltoro`.`alerts` (`date`, `iddevice`, `BUS_iddevice`, `sensor_key`, `idgroup_home`, `description`, `type_alert`, `iduser`, `limit_inf`, `limit_sup`, `formula`, `email`, `iddevice_compare`, `BUS_iddevice_compare`, `iddata_type`, `time_range`, `start_at`, `end_at`, `timezone`)
                SELECT	
                            NOW() AS date,
                            ExtractValue(alert_XML, 'alert/iddevice') AS iddevice,
                            IF(ExtractValue(alert_XML, 'alert/BUS_iddevice')='', NULL,ExtractValue(alert_XML, 'alert/BUS_iddevice')) AS BUS_iddevice,
                            IF(ExtractValue(alert_XML, 'alert/sensor_key')='', NULL,ExtractValue(alert_XML, 'alert/sensor_key')) AS sensor_key,
                            idgroup_var AS idgroup_home,
                            IF(ExtractValue(alert_XML, 'alert/description')='', NULL,ExtractValue(alert_XML, 'alert/description')) AS description,
                            ExtractValue(alert_XML, 'alert/type_alert') AS type_alert,
                            iduser_var AS iduser,
                            IF(ExtractValue(alert_XML, 'alert/limit_inf')='', NULL,ExtractValue(alert_XML, 'alert/limit_inf')) AS limit_inf,                                            
                            IF(ExtractValue(alert_XML, 'alert/limit_sup')='', NULL,ExtractValue(alert_XML, 'alert/limit_sup')) AS limit_sup,
                            IF(ExtractValue(alert_XML, 'alert/formula')='', NULL,ExtractValue(alert_XML, 'alert/formula')) AS formula,
                            IF(ExtractValue(alert_XML, 'alert/email')='', NULL,ExtractValue(alert_XML, 'alert/email')) AS email,
                            IF(ExtractValue(alert_XML, 'alert/iddevice_compare')='', NULL,ExtractValue(alert_XML, 'alert/iddevice_compare')) AS iddevice_compare,
                            IF(ExtractValue(alert_XML, 'alert/BUS_iddevice_compare')='', NULL,ExtractValue(alert_XML, 'alert/BUS_iddevice_compare')) AS BUS_iddevice_compare,
                            IF(ExtractValue(alert_XML, 'alert/iddata_type')='', NULL,ExtractValue(alert_XML, 'alert/iddata_type')) AS iddata_type,
                            ExtractValue(alert_XML, 'alert/time_range') AS time_range,
                            ExtractValue(alert_XML, 'alert/start_at') AS start_at,
                            ExtractValue(alert_XML, 'alert/end_at') AS end_at,
                            (SELECT timezone FROM e3t.devices where id in (ExtractValue(alert_XML, 'alert/iddevice')) LIMIT 1) AS timezone;

            SELECT id FROM baltoro.alerts
                WHERE iddevice = ExtractValue(alert_XML, 'alert/iddevice')
                AND formula = IF(ExtractValue(alert_XML, 'alert/formula') = '', NULL, ExtractValue(alert_XML, 'alert/formula'))
                AND description = IF(ExtractValue(alert_XML, 'alert/description') = '', NULL, ExtractValue(alert_XML, 'alert/description'))
                LIMIT 1;

        END
		$$
		

    -- POST_alert_log

        DELIMITER $$
        DROP PROCEDURE IF EXISTS POST_alert_log;
        $$

        CREATE PROCEDURE `POST_alert_log`( id_alert_var INT(11), value_inf_var VARCHAR(45), value_sup_var VARCHAR(45), night_compsuption_var VARCHAR(45), values_var TEXT )
        BEGIN

            INSERT INTO `baltoro`.`alerts_log` (`id_alert`, `date`, `value_inf`, `vaule_sup`, `night_compsuption`, `values`) 
                    VALUES (id_alert_var, NOW(), value_inf_var, value_sup_var, night_compsuption_var, `values`);
                    
            UPDATE `baltoro`.`alerts` SET `active` = '1' WHERE (`id` = id_alert_var);

        END
		$$
		

    -- POST_password_reset

        DELIMITER $$
        DROP PROCEDURE IF EXISTS POST_password_reset;
        $$    

        CREATE PROCEDURE `POST_password_reset`(iduser_var INT,  iduser_edit_var INT)
        PROC:BEGIN

            DECLARE miFechaHora TIMESTAMP;
            SET miFechaHora = NOW();

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

                IF @result=0
                THEN
                    SELECT 'Validation' ERROR;
                    LEAVE PROC;
                END IF;	
            
            INSERT INTO `baltoro`.`user_password_reset` (`id`, `password_reset`, `timestamp`)
            VALUES (iduser_edit_var, 1, miFechaHora)
            ON DUPLICATE KEY UPDATE `password_reset` = 1, `timestamp` = miFechaHora;

        END
		$$
		

    -- POST_register_token

        DELIMITER $$
        DROP PROCEDURE IF EXISTS POST_register_token;
        $$

        CREATE PROCEDURE `POST_register_token`(iduser_var VARCHAR(45), token_plain_var VARCHAR(200))
        BEGIN

            SET SQL_SAFE_UPDATES = 0;

            UPDATE baltoro.personal_access_tokens SET `token_api` = token_plain_var WHERE name = iduser_var ;

        END
		$$
		

    -- POST_register_user_conexion

        DELIMITER $$
        DROP PROCEDURE IF EXISTS POST_register_user_conexion;
        $$

        CREATE PROCEDURE `POST_register_user_conexion`(iduser_var INT, host_var VARCHAR(50))
        BEGIN

            INSERT INTO `baltoro`.`users_history` (`iduser`, `date`, `host`) VALUES (iduser_var, NOW(), host_var);

        END
		$$
		

    -- POST_sector

        DELIMITER $$
        DROP PROCEDURE IF EXISTS POST_sector;
        $$

        CREATE PROCEDURE `POST_sector`(iduser_var int, idgroup_var INT, sector_XML TEXT CHARSET UTF8)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result);

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                    
            INSERT  `baltoro`.`sector_labels` (`idgroup`, `name`, `tag`, `description`) 
                SELECT 
                    idgroup_var AS idgroup,
                    IF(ExtractValue(sector_XML, 'sector/name')='', NULL,ExtractValue(sector_XML, 'sector/name')) AS name,
                    IF(ExtractValue(sector_XML, 'sector/tag')='', NULL,ExtractValue(sector_XML, 'sector/tag')) AS tag,
                    IF(ExtractValue(sector_XML, 'sector/description')='', NULL,ExtractValue(sector_XML, 'sector/description')) AS description;
        END
		$$
		

    -- POST_sector_gateway

        DELIMITER $$
        DROP PROCEDURE IF EXISTS POST_sector_gateway;
        $$

        CREATE PROCEDURE `POST_sector_gateway`(iduser_var int, iddevice_var INT, idsector_var INT, function_var VARCHAR(45))
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=iddevice_var, @result);

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                    
            UPDATE baltoro.labels_iddevice LD
                SET `sectors` = (SELECT JSON_SET(sectors, CONCAT('$."', idsector_var, '"'), function_var))
                WHERE LD.iddevice=iddevice_var;
        END
		$$
		

    -- POST_service

        DELIMITER $$
        DROP PROCEDURE IF EXISTS POST_service;
        $$

        CREATE PROCEDURE `POST_service`(iduser_var INT, idgroup_var INT, service_XML TEXT CHARSET UTF8)
        PROC:BEGIN

                CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                        
            INSERT  `baltoro`.`service_labels` (`idgroup`, `name`, `description`, `color`, `tag`) 
                SELECT 
                    idgroup_var AS idgroup,
                    IF(ExtractValue(service_XML, 'service/name')='', NULL,ExtractValue(service_XML, 'service/name')) AS name,
                    IF(ExtractValue(service_XML, 'service/description')='', NULL,ExtractValue(service_XML, 'service/description')) AS description,
                    IF(ExtractValue(service_XML, 'service/color')='', NULL,ExtractValue(service_XML, 'service/color')) AS color,
                    IF(ExtractValue(service_XML, 'service/tag')='', NULL,ExtractValue(service_XML, 'service/tag')) AS tag;
                    
        END
		$$
		

    -- POST_user

        DELIMITER $$
        DROP PROCEDURE IF EXISTS POST_user;
        $$

        CREATE PROCEDURE `POST_user`(iduser_var INT, user_XML TEXT CHARSET UTF8)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
            
            INSERT `baltoro`.`users`  (`user`, `name`, `email`, `password`, `idgroup_home`, `timezone`, `language`, `admin`, `updated_at`, `created_at`)
                SELECT 
                IF(ExtractValue(user_XML, 'userXML/user')='', null,ExtractValue(user_XML, 'userXML/user')) AS user,
                IF(ExtractValue(user_XML, 'userXML/name')='', null,ExtractValue(user_XML, 'userXML/name')) AS name,
                IF(ExtractValue(user_XML, 'userXML/email')='', null,ExtractValue(user_XML, 'userXML/email')) AS email,
                IF(ExtractValue(user_XML, 'userXML/password')='', null,ExtractValue(user_XML, 'userXML/password')) AS password,
                IF(ExtractValue(user_XML, 'userXML/idgroup_home')='', null,ExtractValue(user_XML, 'userXML/idgroup_home')) AS idgroup_home,
                IF(ExtractValue(user_XML, 'userXML/timezone')='', null,ExtractValue(user_XML, 'userXML/timezone')) AS timezone,
                IF(ExtractValue(user_XML, 'userXML/language')='', null,ExtractValue(user_XML, 'userXML/language')) AS language,
                IF(ExtractValue(user_XML, 'userXML/admin')='', null,ExtractValue(user_XML, 'userXML/admin')) AS admin,
                IF(ExtractValue(user_XML, 'userXML/updated_at')='', null,ExtractValue(user_XML, 'userXML/updated_at')) AS updated_at,
                IF(ExtractValue(user_XML, 'userXML/created_at')='', null,ExtractValue(user_XML, 'userXML/created_at')) AS created_at;            

            SELECT id FROM baltoro.users order by id desc LIMIT 1;

        END
		$$
		

-- END POST

-- START PUT
    -- PUT_alert

        DELIMITER $$
        DROP PROCEDURE IF EXISTS PUT_alert;
        $$

        CREATE PROCEDURE `PUT_alert`(iduser_var INT, idalert_var INT(11), alert_XML TEXT CHARSET UTF8)
        PROC:BEGIN

                                DECLARE pre_iddevice text;
                                DECLARE pre_BUS_iddevice text;
                                DECLARE pre_sensor_key varchar(45);
                                DECLARE pre_description varchar(45);
                                DECLARE pre_type_alert varchar(45);
                                DECLARE pre_email varchar(45);
                                DECLARE pre_iddata_type int(11);
                                DECLARE pre_time_range varchar(45);
                                DECLARE pre_limit_inf varchar(45);
                                DECLARE pre_limit_sup varchar(45);
                                DECLARE pre_formula varchar(127);
                                DECLARE pre_enabled int(1);

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                    
            
                /*
                CALL baltoro.PUT_alert ('6574567456ghik',1,
                                    '<alert>
                                        <iddevice>4</iddevice>
                                        <BUS_iddevice>4</BUS_iddevice>
                                        <description>21231</description>
                                        <type_alert>2</type_alert>
                                        <limit_inf>5</limit_inf>
                                        <limit_sup>20</limit_sup>
                                        <email>jrudila@datakorum.com</email>
                                        <iddevice_compare>3</iddevice_compare>
                                        <BUS_iddevice_compare>1</BUS_iddevice_compare>
                                    </alert>' );
            */
            
            SELECT `iddevice`, `BUS_iddevice`, `sensor_key`, `description`, `type_alert`, `email`, `iddata_type`, `time_range`, `limit_inf`, `limit_sup`, `formula`, `enabled` FROM `baltoro`.`alerts` WHERE `id` = idalert_var
            INTO pre_iddevice, pre_BUS_iddevice, pre_sensor_key, pre_description, pre_type_alert, pre_email, pre_iddata_type, pre_time_range, pre_limit_inf, pre_limit_sup, pre_formula, pre_enabled;                 
            
            UPDATE  `baltoro`.`alerts` SET 
                                iddevice 							= 	IF(ExtractValue(alert_XML, 'alert/iddevice')='', pre_iddevice,ExtractValue(alert_XML, 'alert/iddevice')),
                                BUS_iddevice						= 	IF(ExtractValue(alert_XML, 'alert/BUS_iddevice')='', pre_BUS_iddevice,ExtractValue(alert_XML, 'alert/BUS_iddevice')),
								sensor_key							= 	IF(ExtractValue(alert_XML, 'alert/sensor_key')='', pre_sensor_key,ExtractValue(alert_XML, 'alert/sensor_key')),
                                description							= 	IF(ExtractValue(alert_XML, 'alert/description')='', pre_description,ExtractValue(alert_XML, 'alert/description')),
                                type_alert							= 	IF(ExtractValue(alert_XML, 'alert/type_alert')='', pre_type_alert,ExtractValue(alert_XML, 'alert/type_alert')),
                                email								=	IF(ExtractValue(alert_XML, 'alert/email')='', pre_email,ExtractValue(alert_XML, 'alert/email')),                        
                                iddata_type							=	IF(ExtractValue(alert_XML, 'alert/iddata_type')='', pre_iddata_type,ExtractValue(alert_XML, 'alert/iddata_type')),
                                time_range							=	IF(ExtractValue(alert_XML, 'alert/time_range')='', pre_time_range,ExtractValue(alert_XML, 'alert/time_range')),
                                limit_inf 							= 	IF(ExtractValue(alert_XML, 'alert/limit_inf')= 'null', pre_limit_inf, 
                                                                            IF(ExtractValue(alert_XML, 'alert/limit_inf')='', null, 
                                                                                ExtractValue(alert_XML, 'alert/limit_inf'))),
                                limit_sup 							= 	IF(ExtractValue(alert_XML, 'alert/limit_sup')= 'null', pre_limit_sup, 
                                                                            IF(ExtractValue(alert_XML, 'alert/limit_sup')='', null, 
                                                                                ExtractValue(alert_XML, 'alert/limit_sup'))),
                                formula 		 					= 	IF(ExtractValue(alert_XML, 'alert/formula')= 'null', pre_formula, 
                                                                            IF(ExtractValue(alert_XML, 'alert/formula')='', null, 
                                                                                ExtractValue(alert_XML, 'alert/formula'))),
                                enabled 							= 	IF(ExtractValue(alert_XML, 'alert/enabled')='', pre_enabled,ExtractValue(alert_XML, 'alert/enabled'))
            WHERE id=idalert_var;
                            
        END
		$$
		

    -- PUT_alert_timetable

        DELIMITER $$
        DROP PROCEDURE IF EXISTS PUT_alert_timetable;
        $$

        CREATE PROCEDURE `PUT_alert_timetable`(iduser_var INT, idalert_var INT(11), alert_XML TEXT CHARSET UTF8)
        PROC:BEGIN
            DECLARE pre_start_at time;
            DECLARE pre_end_at time;
            DECLARE pre_enabledDays int(11);

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
            
            SELECT `start_at`, `end_at`, `enabledDays` FROM `baltoro`.`alerts` WHERE `id` = idalert_var
            INTO pre_start_at, pre_end_at, pre_enabledDays;                 
            
            UPDATE  `baltoro`.`alerts` SET 
                                start_at = IF(ExtractValue(alert_XML, 'alert/start_at')='', pre_start_at,ExtractValue(alert_XML, 'alert/start_at')),
                                end_at = IF(ExtractValue(alert_XML, 'alert/end_at')='', pre_end_at,ExtractValue(alert_XML, 'alert/end_at')),
                                enabledDays = IF(ExtractValue(alert_XML, 'alert/enabledDays')='', pre_enabledDays,ExtractValue(alert_XML, 'alert/enabledDays'))
            WHERE id=idalert_var;
                            
        END
		$$
		

    -- PUT_alert_log

        DELIMITER $$
        DROP PROCEDURE IF EXISTS PUT_alert_log;
        $$

        CREATE PROCEDURE `PUT_alert_log`(iduser_var INT, id_alert_log_var INT(11), read_var INT(1) )
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                    

            UPDATE `baltoro`.`alerts_log` SET `read` = read_var WHERE (`id` = id_alert_log_var);

        END
		$$
		

    -- PUT_gateway_info

        DELIMITER $$
        DROP PROCEDURE IF EXISTS PUT_gateway_info;
        $$

        CREATE PROCEDURE `PUT_gateway_info`(iduser_var INT, iddevice_var INT, gateway_XML TEXT CHARSET UTF8)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                    
            /*
            CALL baltoro.PUT_gateway_info ( 8, '<gateway>
                                        <name>F11, F5 Av Campanar</name>
                                        <GPS_lat>1</GPS_lat>
                                        <GPS_lng>7</GPS_lng>
                                    </gateway>' )
            */
            
            UPDATE e3t.devices SET 	
                                name = 		ExtractValue(gateway_XML, 'gateway/name'),
                                GPS_lat = 	ExtractValue(gateway_XML, 'gateway/GPS_lat'),
                                GPS_lng = 	ExtractValue(gateway_XML, 'gateway/GPS_lng')
            WHERE id = iddevice_var;
        
            IF ROW_COUNT()>0
                THEN
                    SELECT 1 response;
                ELSE
                    SELECT 0 response;
            END IF;
            
        END
		$$
		

    -- PUT_group_info

        DELIMITER $$
        DROP PROCEDURE IF EXISTS PUT_group_info;
        $$

        CREATE PROCEDURE `PUT_group_info`(iduser_var INT, idgroup_var INT, group_XML TEXT CHARSET UTF8)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=idgroup_var, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                        /*
            CALL baltoro.PUT_group_info ('token', 8, '<group>
                                        <description>F11, F5 Av Campanar</description>
                                        <GPS_lat>1</GPS_lat>
                                        <GPS_lng>7</GPS_lng>
                                    </group>' )
            */
            
            UPDATE e3t.`groups` SET 	
                                description = 	ExtractValue(group_XML, 'group/description'),
                                GPS_lat = 		ExtractValue(group_XML, 'group/GPS_lat'),
                                GPS_lng = 		ExtractValue(group_XML, 'group/GPS_lng')
            WHERE id = idgroup_var;
        
            IF ROW_COUNT()>0
                THEN
                    SELECT 1 response;
                ELSE
                    SELECT 0 response;
            END IF;
            
        END
		$$
		

    -- PUT_meter_info

        DELIMITER $$
        DROP PROCEDURE IF EXISTS PUT_meter_info;
        $$

        CREATE PROCEDURE `PUT_meter_info`(iduser_var INT, iddevice_var INT,  BUS_iddevice_var VARCHAR(45), descriptors_BUS_XML TEXT CHARSET UTF8)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=iddevice_var, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                    
            SELECT descriptors_BUS from e3t.middleware_udp_devices_BUS_devices WHERE iddevice=iddevice_var and BUS_iddevice = BUS_iddevice_var;
            
            UPDATE e3t.middleware_udp_devices_BUS_devices SET descriptors_BUS = descriptors_BUS_XML WHERE iddevice=iddevice_var and BUS_iddevice = BUS_iddevice_var;
            
            IF ROW_COUNT()>0
                THEN
                    SELECT 1 response;
                ELSE
                    SELECT 0 response;
            END IF;
            
        END
		$$
		

    -- PUT_reset_password_token

        DELIMITER $$
        DROP PROCEDURE IF EXISTS PUT_reset_password_token;
        $$

        CREATE PROCEDURE `PUT_reset_password_token`(iduser_var INT, token_var varchar(150), password_var varchar(100))
        proc_label:begin

            DECLARE miFechaHora datetime;
	        SET miFechaHora = NOW();
            
            IF EXISTS(SELECT * FROM baltoro.reset_password_tokens WHERE iduser=iduser_var AND token=token_var)
            THEN
                DELETE FROM baltoro.reset_password_tokens WHERE iduser = iduser_var AND token = token_var;
                UPDATE `baltoro`.`users` SET `password` = password_var, `updated_at` = miFechaHora WHERE (`id` = iduser_var);
                SELECT 1 message;
            ELSE
                SELECT 0 error;
            END IF;
            
        END
		$$
		

    -- PUT_sector

        DELIMITER $$
        DROP PROCEDURE IF EXISTS PUT_sector;
        $$

        CREATE PROCEDURE `PUT_sector`(iduser_var INT, idservice_var INT, sector_XML TEXT CHARSET UTF8)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                    
            UPDATE `baltoro`.`sector_labels` 
                SET 
                `name` = IF(ExtractValue(sector_XML, 'sector/name')='', NULL,ExtractValue(sector_XML, 'sector/name')),
                `description` = IF(ExtractValue(sector_XML, 'sector/description')='', NULL,ExtractValue(sector_XML, 'sector/description')),
                `tag` = IF(ExtractValue(sector_XML, 'sector/tag')='', NULL,ExtractValue(sector_XML, 'sector/tag'))
                WHERE (`id` = idservice_var);

        END
		$$
		

    -- PUT_service

        DELIMITER $$
        DROP PROCEDURE IF EXISTS PUT_service;
        $$

        CREATE PROCEDURE `PUT_service`(iduser_var INT, idservice_var INT, service_XML TEXT CHARSET UTF8)
        PROC:BEGIN

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                    
            UPDATE `baltoro`.`service_labels` 
                SET 
                `name` = IF(ExtractValue(service_XML, 'service/name')='', NULL,ExtractValue(service_XML, 'service/name')),
                `description` = IF(ExtractValue(service_XML, 'service/description')='', NULL,ExtractValue(service_XML, 'service/description')),
                `color` = IF(ExtractValue(service_XML, 'service/color')='', NULL,ExtractValue(service_XML, 'service/color')),
                `tag` = IF(ExtractValue(service_XML, 'service/tag')='', NULL,ExtractValue(service_XML, 'service/tag'))
                WHERE (`id` = idservice_var);

        END
		$$
		

    -- PUT_service_sector_gateway

        DELIMITER $$
        DROP PROCEDURE IF EXISTS PUT_service_sector_gateway;
        $$

        CREATE PROCEDURE `PUT_service_sector_gateway`(iduser_var INT, iddevice_var INT, sectors_var TEXT, idservice_var INT)
        PROC:BEGIN

            DECLARE row_var INT(1);

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=iddevice_var, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
                        
            SET row_var = (SELECT COUNT(id) from `baltoro`.`labels_iddevice` WHERE iddevice = iddevice_var);

            
            IF row_var > 0
                THEN
                    SET @consulta= CONCAT('UPDATE `baltoro`.`labels_iddevice` SET ');
                                                                
                    IF (sectors_var !='0' AND idservice_var = 0)
                        THEN
                            SET @consulta=CONCAT(@consulta, "`sectors` = '", sectors_var,"'");
                    END IF;
                            
                    IF (idservice_var !=0 AND sectors_var = '0')	
                        THEN
                            SET @consulta=CONCAT(@consulta, '`idservice` = ', idservice_var);
                    END IF;
                            
                    IF (idservice_var !=0 AND sectors_var != '0')	
                        THEN
                            SET @consulta=CONCAT(@consulta, "`sectors` = '", sectors_var, "', `idservice` = ", idservice_var);
                    END IF;
                    
                    SET @consulta=CONCAT(@consulta, ' WHERE iddevice = ', iddevice_var, ';');
                    
                ELSE
                
                    IF (sectors_var !=0 AND idservice_var = 0)
                        THEN
                            SET @consulta= CONCAT('INSERT  `baltoro`.`labels_iddevice` (`iddevice`, `sectors`) SELECT 
                            iddevice_var AS iddevice,
                            sectors_var AS sectors;
                            ');
                    END IF;
                            
                    IF (idservice_var !=0 AND sectors_var = 0)	
                        THEN
                            SET @consulta= CONCAT('INSERT  `baltoro`.`labels_iddevice` (`iddevice`, `idservice`) SELECT 
                            iddevice_var AS iddevice,
                            idservice_var AS idservice;');
                    END IF;
                            
                    IF (idservice_var !=0 AND sectors_var != 0)	
                        THEN
                            SET @consulta= CONCAT('INSERT  `baltoro`.`labels_iddevice` (`iddevice`, `sectors`, idservice`) SELECT 
                            ', iddevice_var,' AS iddevice,
                            ', sectors_var,' AS sectors,
                            ', idservice_var,' AS idservice;
                            ');
                    END IF;
            END IF;
            
            -- SELECT @consulta;
                    -- preparamos el objete Statement a partir de nuestra variable
            PREPARE smpt FROM @consulta;
                -- ejecutamos el Statement
            EXECUTE smpt;
                -- liberamos la memoria
            DEALLOCATE PREPARE smpt;
        END
		$$
		

    -- PUT_user

        DELIMITER $$
        DROP PROCEDURE IF EXISTS PUT_user;
        $$

        CREATE PROCEDURE `PUT_user`(iduser_var INT, iduser_edit_var INT, user_XML TEXT CHARSET UTF8)
        PROC:BEGIN

            DECLARE pre_user varchar(50);  
            DECLARE pre_name varchar(200); 
            DECLARE pre_email varchar(45);  
            DECLARE pre_password varchar(100); 
            DECLARE pre_idgroup_home int(11);  
            DECLARE pre_timezone varchar(45); 
            DECLARE pre_language varchar(45);  
            DECLARE pre_admin int(11); 
            DECLARE pre_updated_at datetime; 

            CALL baltoro.Validate_access (@iduser_var:=iduser_var, @idgroup_var:=0, @iddevice_var:=0, @result); 

            IF @result=0
            THEN
                SELECT 'Validation' ERROR;
                LEAVE PROC;
            END IF;	
            
            SELECT `user`, `name`, `email`, `password`, `idgroup_home`, `timezone`, `language`, `admin`, `updated_at` FROM `baltoro`.`users` WHERE `id` = iduser_edit_var
            INTO pre_user, pre_name, pre_email, pre_password, pre_idgroup_home, pre_timezone, pre_language, pre_admin, pre_updated_at;   

            UPDATE `baltoro`.`users` 
                SET 
                `user` = IF(ExtractValue(user_XML, 'user/username')='', pre_user,ExtractValue(user_XML, 'user/username')),
                `name` = IF(ExtractValue(user_XML, 'user/name')='', pre_name,ExtractValue(user_XML, 'user/name')),
                `email` = IF(ExtractValue(user_XML, 'user/email')='', pre_email,ExtractValue(user_XML, 'user/email')),
                `password` = IF(ExtractValue(user_XML, 'user/password')='', pre_password,ExtractValue(user_XML, 'user/password')),
                `idgroup_home` = IF(ExtractValue(user_XML, 'user/idgroup_home')='', pre_idgroup_home,ExtractValue(user_XML, 'user/idgroup_home')),
                `timezone` = IF(ExtractValue(user_XML, 'user/timezone')='', pre_timezone,ExtractValue(user_XML, 'user/timezone')),
                `language` = IF(ExtractValue(user_XML, 'user/language')='', pre_language,ExtractValue(user_XML, 'user/language')),
                `admin` = IF(ExtractValue(user_XML, 'user/admin')='', pre_admin,ExtractValue(user_XML, 'user/admin')),
                `updated_at` = IF(ExtractValue(user_XML, 'user/updated_at')='', pre_updated_at,ExtractValue(user_XML, 'user/updated_at'))
                WHERE (`id` = iduser_edit_var);

        END
		$$
		

-- END PUT

-- START VALIDATE
    -- Validate_access

        DELIMITER $$
        DROP PROCEDURE IF EXISTS Validate_access;
        $$

        CREATE PROCEDURE `Validate_access`(iduser_var INT, idgroup_var INT, iddevice_var INT, OUT result_var INT )
        BEGIN
            SET @ok=1;

            SELECT id, idgroup_home 
            FROM baltoro.users WHERE id=iduser_var
            INTO @iduser, @idgroup_home;

            IF FOUND_ROWS()=0
            THEN
                SET @ok=0;
            ELSE

                DROP TEMPORARY TABLE IF EXISTS Temp_Table_groups;
                CREATE TEMPORARY TABLE Temp_Table_groups (id int NOT NULL PRIMARY KEY AUTO_INCREMENT, idgroup int NOT NULL, KEY idgroup (idgroup));

                CALL baltoro.Hierarchical_group_subgroups ( @idgroup_home );
                
                IF @ok=1 AND iduser_var>0
                THEN
                    SET @ok=IFNULL((SELECT 1 FROM baltoro.users U 
                                    INNER JOIN Temp_Table_groups TTG ON TTG.idgroup=U.idgroup_home 
                                    WHERE U.id=iduser_var), 0);
                END IF;

                IF @ok=1 AND idgroup_var>0
                THEN
                    SET @ok=IFNULL((SELECT 1 FROM e3t.`groups` G 
                                    INNER JOIN Temp_Table_groups TTG ON TTG.idgroup=G.id 
                                    WHERE G.id=idgroup_var), 0);
                END IF;

                IF @ok=1 AND iddevice_var>0
                THEN
                    SET @ok=IFNULL((SELECT 1 FROM e3t.devices D 
                                    INNER JOIN Temp_Table_groups TTG ON TTG.idgroup=D.idgroup 
                                    WHERE D.id=iddevice_var), 0);
                END IF;

            END IF;

            SET result_var = @ok;
        END
		$$
		

    -- Validate_session

        DELIMITER $$
        DROP PROCEDURE IF EXISTS Validate_session;
        $$

        CREATE PROCEDURE `Validate_session`(token_var VARCHAR(255), iduser_var INT, idgroup_var INT, iddevice_var INT, OUT result_var INT )
        BEGIN
            SET @ok=1;

            SELECT U.id, U.idgroup_home 
            FROM baltoro.sessions S
            INNER JOIN baltoro.users U ON U.id = S.user_id
            WHERE S.id=token_var
            INTO @iduser, @idgroup_home;

            if FOUND_ROWS()=0
            then
                SET @ok=0;
            else

                DROP TEMPORARY TABLE IF EXISTS Temp_Table_groups;
                CREATE TEMPORARY TABLE Temp_Table_groups (id int NOT NULL PRIMARY KEY AUTO_INCREMENT, idgroup int NOT NULL, KEY idgroup (idgroup));

                CALL baltoro.Hierarchical_group_subgroups ( @idgroup_home );
                
                if @ok=1 AND iduser_var>0
                then
                    SET @ok=IFNULL((SELECT 1 FROM baltoro.users U 
                                    INNER JOIN Temp_Table_groups TTG ON TTG.idgroup=U.idgroup_home 
                                    WHERE U.id=iduser_var), 0);
                end if;

                if @ok=1 AND idgroup_var>0
                then
                    SET @ok=IFNULL((SELECT 1 FROM e3t.`groups` G 
                                    INNER JOIN Temp_Table_groups TTG ON TTG.idgroup=G.id 
                                    WHERE G.id=idgroup_var), 0);
                end if;

                if @ok=1 AND iddevice_var>0
                then
                    SET @ok=IFNULL((SELECT 1 FROM e3t.devices D 
                                    INNER JOIN Temp_Table_groups TTG ON TTG.idgroup=D.idgroup 
                                    WHERE D.id=iddevice_var), 0);
                end if;

            end if;

            set result_var = @ok;
        END
		$$

-- END VALIDATE